
from PyQt4.QtCore import SIGNAL, Qt
from PyQt4.QtGui import QWidget, QLabel, QLineEdit, QPushButton, QVBoxLayout, QSizePolicy

from sfadata import SfaData
from sfascreen import SfaScreen

class ConfigWidget(QWidget):
    def __init__(self, parent=None):
        QWidget.__init__(self, parent)

        self.data = SfaData()

        label1 = QLabel("User HRN:", self)
        self.user = QLineEdit(self.data.getUser(), self)
        label2 = QLabel("Slice HRN:", self)
        self.slice = QLineEdit(self.data.getSlice(), self)
        apply = QPushButton("Apply", self)
        apply.setSizePolicy(QSizePolicy.Maximum, QSizePolicy.Maximum)
        
        layout = QVBoxLayout()
        layout.addWidget(label1)
        layout.addWidget(self.user)
        layout.addWidget(label2)
        layout.addWidget(self.slice)
        layout.addWidget(apply, 0, Qt.AlignRight)
        self.setLayout(layout)

        self.connect(apply, SIGNAL('clicked()'),
                     self.apply)

    def apply(self):
        self.data.setUser("%s" % self.user.text())
        self.data.setSlice("%s" % self.slice.text())
        self.data.save_config()
        

class SfaConfigScreen(SfaScreen):
    def __init__(self, parent=None):
        SfaScreen.__init__(self, parent)
        
        config = ConfigWidget(self)
        self.init(config, "Configure", "Configure the PlanetLab Federation GUI")
